<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Food Ordering</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="Food Ordering.css">
    <link rel="stylesheet" href="giohang.css">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Squada+One&display=swap" rel="stylesheet">
    <link href="https://fonts.cdnfonts.com/css/sf-pro-display" rel="stylesheet">
    <link href="https://fonts.cdnfonts.com/css/gilroy-bold" rel="stylesheet">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.5/font/bootstrap-icons.css">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link
        href="https://fonts.googleapis.com/css2?family=Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;1,100;1,200;1,300;1,400;1,500;1,600;1,700&display=swap"
        rel="stylesheet">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Lexend+Deca:wght@400;500;600;700&display=swap"
        rel="stylesheet">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=ABeeZee:ital@0;1&display=swap" rel="stylesheet">
</head>

<body>
    <!-- <div class="overlay container-fluid">
        <div class="spinner-border" style="width: 3rem; height:3rem;"></div>
    </div> -->
    <!-- HEADER SECTION -->
    <div class="container-fluid header-layout">
        <nav class="row navbar navbar-expand-lg navbar-dark">
            <div class="col-sm-3 text-center">
                <a class="navbar-brand header-brand" href="#">WHAT2EAT</a>
            </div>
            <div class=" col-sm-6 text-center header-nav-list navbar-expand" id="navbarNav">
                <ul class="navbar-nav text-center">
                    <li class="nav-item active">
                        <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
                    </li>
                    <li class="nav-item active">
                        <a class="nav-link" href="#">About</a>
                    </li>
                    <li class="nav-item active">
                        <a class="nav-link" href="#">Menu</a>
                    </li>
                    <li class="nav-item active">
                        <a class="nav-link" href="#">Blog</a>
                    </li>
                    <li class="nav-item active">
                        <a class="nav-link" href="#">Contact</a>
                    </li>
                </ul>
            </div>
            <div class="col-sm-3 header-nav-icon d-flex align-items-center justify-content-center">
                <i class="bi bi-search icon-search"></i>
                <i class="bi bi-handbag"></i>
            </div>
        </nav>
        <!-- HEADER BODY -->
        <div class="header-body jumbotron d-flex align-items-center">
            <div class="row header-body-row">
                <div class="col-sm-6 jumbotron left-side d-flex align-items-center">
                    <div class="left-side-info">
                        <div class="left-side-text">
                            <h2>Authentic Home food in UK</h2>
                            <p>What2Eat is a courier service in which authentic home cook food is delivered to a
                                customer.</p>
                        </div>
                        <div class="left-side-search-input d-flex flex-row ">
                            <div class="col-sm-6 input-search">
                                <input class="rounded-left form-control" type="text" placeholder="Search food you love">
                            </div>
                            <div class="col-sm-6 text-left btn-search">
                                <button class="btn rounded-left btn-warning button-search">Search</button>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-sm-6 text-center jumbotron right-side">
                    <div class="right-side-img">
                        <img src="images/cooking.man.header.svg" alt="">
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- CART SECTION -->
    <div class="overlay-cart container-fluid">
        <div class="spinner-border" id="spinner-content" style="width: 3rem; height:3rem;"></div>
    </div>
    <div class="cart-container">
        <div class="nav-cart d-flex justify-content-center mt-5">
            <ul class="nav ">
                <li class="nav-item">
                    <a class="nav-link active text-success" href="#">Home</a>
                </li>
                <li class="nav-item">
                    <span class="nav-link active" href="#">/</span>
                </li>
                <li class="nav-item">
                    <a class="nav-link text-success" href="#">Trending</a>
                </li>
                <li class="nav-item">
                    <span class="nav-link active" href="#">/</span>
                </li>
                <li class="nav-item ">
                    <a class="nav-link text-dark" href="#">Famous Tandoor</a>
                </li>
            </ul>
        </div>
        <!-- PAY SECTION -->
        <section class="payment" id="payment-section">

            <div class="payment-container">
                <div class="payment-header row">
                    <div class="col-6" id="payment-header-leftside">PRODUCT</div>
                    <div class="col-6 " id="payment-header-rightside">
                        <ul class="d-flex justify-content-end w-100">
                            <li>PRICE</li>
                            <li>QTY</li>
                            <li>UNIT <br> PRICE</li>
                        </ul>
                    </div>
                </div>

                <div class="payment-wrapper">

                    <div class="pizza-order-container">

                    </div>

                    <div class="container-total-payment row">
                        <div class="col-8 input-btn-group text-right">
                            <div class="row ">
                                <div class="col-11">
                                    <div class="input-group input-btn-group mb-3">
                                        <input type="text" class="form-control input-voucher-code"
                                            placeholder="Voucher code" aria-label="Recipient's username"
                                            aria-describedby="basic-addon2">
                                        <div>
                                            <span id="basic-addon2"><button class="btn btn-redeem">Redeem</button>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-4 text-right final-price-container">
                            <div class="row div-subtotal">
                                <div class="col-6 text-left">Subtotal</div>
                                <div class="col-6 text-right subtotal-price">$998</div>
                            </div>
                            <div class="row div-shipping-fee">
                                <div class="col-6 text-left">Shipping fee</div>
                                <div class="col-6 text-right shipping-price">$20</div>
                            </div>
                            <div class="row div-coupon">
                                <div class="col-6 text-left">Coupon</div>
                                <div class="col-6 text-right coupon-code">No</div>
                            </div>

                            <div class="row div-final-price">
                                <div class="col-6 text-left total-price-text">TOTAL</div>
                                <div class="col-6 text-right total-price-number">$1018</div>
                            </div>
                            <div class="row mt-2 div-check-out">
                                <button class=" btn w-100" id="btn-check-out">Check out</button>
                            </div>
                        </div>

                    </div>
                </div>
        </section>
    </div>

    <!-- MODAL PAYMENT -->
    <div class="modal  modal-payment" tabindex="-1" role="dialog" id="meow">
        <div class="modal-dialog modal-xl">
            <div class="modal-content">
                <div class="modal-header modal-header-restyle">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span id="cross-icon" aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-title text-center mb-3">
                    <h5 class="modal-title-text">Make Payment</h5>
                </div>
                <div class="modal-progress">
                    <div class="progress-container">
                        <ul class="progressbar text-center">
                            <li class="progress-active"></li>
                            <li></li>
                        </ul>
                    </div>
                </div>
                <div class="modal-body modal-body-container">
                    <div class="row modal-row">
                        <div class="col-6 modal-right-side text-center">
                            <div class="row mb-4">
                                <input class="form-control" id="input-firstname" type="text" placeholder="First Name"
                                    required>
                                <div class="invalid-feedback text-left"></div>
                            </div>
                            <div class="row mb-4">
                                <input class="form-control" id="input-email" type="email" placeholder="Email Address"
                                    required>
                                <div class="invalid-feedback text-left"></div>
                            </div>
                            <div class="method-payment">
                                <div class="d-flex flex-column mb-3">
                                    <div class="row text-left method-payment-title" style="margin-bottom:0px">
                                        Select Method Of Payment
                                    </div>
                                    <div class="row text-danger" id="checkbox-feedback" style="font-size:80%"></div>
                                </div>
                                <div
                                    class=" option-credit-card option-card-method d-flex align-items-center text-left row">
                                    <div class="col-9 col-8-reCss ">
                                        <i class=" bi bi-credit-card"></i>
                                        <span class="ml-2">Credit Card Or Debit</span>
                                    </div>
                                    <div class="col-3 text-right ipt-checkbox div-card-method">
                                        <input name="payment-method" class="payment-checkbox" id="card-method"
                                            type="checkbox">
                                    </div>
                                </div>
                                <!-- Credit Card Or Debit -->
                                <div
                                    class="option-credit-card option-paypal-method d-flex align-items-center text-left row">
                                    <div class="col-9 col-8-reCss">
                                        <i class="bi bi-paypal"></i>
                                        <span class="ml-2">Paypal</span>
                                    </div>
                                    <div class="col-3 ipt-checkbox text-right div-paypal-method">
                                        <input name="payment-method" class="payment-checkbox text-right"
                                            id="paypal-method" type="checkbox">
                                    </div>
                                </div>
                                <!-- Paypal -->
                                <div
                                    class="option-credit-card option-bank-method d-flex align-items-center text-left row">
                                    <div class="col-9 col-8-reCss ">
                                        <i class="bi bi-bank"></i>
                                        <span class="ml-2">Bank Transfer</span>
                                    </div>
                                    <div class="col-3 div-checkbox ipt-checkbox div-bank-method text-right">
                                        <input name="payment-method" class="payment-checkbox text-right"
                                            id="bank-method" type="checkbox">
                                    </div>
                                </div>
                                <!-- Bank Transfer -->
                            </div>
                        </div>
                        <div class="col-6 modal-left-side">
                            <div class="row mb-4">
                                <input class="form-control" id="input-lastname" type="text" placeholder="Last Name"
                                    required>
                                <div class="invalid-feedback"></div>
                            </div>
                            <div class="row mb-4">
                                <textarea class="form-control" name="textarea-message" id="textarea-message" rows="5"
                                    placeholder="Address for Delivery" required></textarea>
                                <div class="invalid-feedback"></div>
                            </div>

                            <div class="row mb-4">
                                <input class="form-control" id="input-phone" type="text" placeholder="Mobile Phone"
                                    required>
                                <div class="invalid-feedback"></div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer border-0 modal-btn-payment justify-content-center">
                    <button type="button" class="btn btn-go-to-payment">Go to Payment</button>
                </div>
            </div>
        </div>
    </div>
    <!-- PAYMENT SUCCESS -->
    <div class="modal modal-success" tabindex="-1" role="dialog" id="lu">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header modal-success-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span id="cross-icon" aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-title text-center mb-3">
                    <div class="modal-success-title">Make Payment</div>
                </div>
                <div class="modal-progress">
                    <div class="progress-container">
                        <ul class="progressbar text-center">
                            <li class="progress-active"></li>
                            <li class="progress-active"></li>
                        </ul>
                    </div>
                </div>
                <div class="modal-body d-flex flex-column align-items-center justify-content-center modal-success-body">
                    <div class="check-cirle"><img src="images/Success Icon.svg" alt=""></div>
                    <div class="title-success">Success</div>
                </div>
                <div class="modal-footer border-0 modal-btn-payment justify-content-center">
                    <button type="button" id="modal-btn-compete" class="btn btn-complete">Complete</button>
                </div>
            </div>
        </div>
    </div>
    <!-- CONFIRM DELETE ORDER -->
    <!-- <div class="modal-delete" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"></h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p>Bạn chắc chắn muốn xóa đơn hàng này?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-primary">Confirm</button>
                </div>
            </div>
        </div>
    </div> -->
    <!-- FOOTER SECTION -->
    <footer class="footer-container">
        <div class="container footer-layout">
            <nav class="row navbar navbar-expand-lg navbar-dark mb-3">
                <div class="col-sm-3 col-3 text-left footer-brand">
                    <a class="footer-brand" href="#">WHAT2EAT</a>
                </div>
                <div class=" col-sm-6 col-6 text-center footer-nav-list navbar-expand" id="navbarNav">
                    <ul class="navbar-nav text-center">
                        <li class="nav-item active">
                            <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
                        </li>
                        <li class="nav-item active">
                            <a class="nav-link" href="#">About</a>
                        </li>
                        <li class="nav-item active">
                            <a class="nav-link" href="#">Menu</a>
                        </li>
                        <li class="nav-item active">
                            <a class="nav-link" href="#">Blog</a>
                        </li>
                        <li class="nav-item active">
                            <a class="nav-link" href="#">Contact</a>
                        </li>
                    </ul>
                </div>
                <div class="col-sm-3 col-3 bottom-nav-icon d-flex align-items-center justify-content-end">
                    <div class="div-icon-facebook">
                        <i class="bi bi-facebook"></i>
                    </div>
                    <div class="div-icon-insta">
                        <i class="bi bi-instagram"></i>
                    </div>
                </div>
            </nav>
            <div class="footer-copyright">
                <div class="footer-copyright-text">Copyright @2021 What2Eat</div>
            </div>
        </div>

    </footer>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    let vOrderPizzaArr = [];
    var gBASE_URL = "https://food-ordering-fvo9.onrender.com/api";

    $(document).ready(function () {
        $(".overlay-cart").hide();
        $('html, body').animate({
            scrollTop: $('#payment-section').offset().top
        }, 'slow');
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        // Lấy dữ liệu từ Local Storage 
        var vOrderPizzaString = localStorage.getItem('Order Pizza');
        vOrderPizzaArr = JSON.parse(vOrderPizzaString);

        //Load đơn hàng lên trang
        displayPizzaOrder(vOrderPizzaArr);
        // Gán sự kiện cho nút Redeem
        $('.btn-redeem').on('click', displayTotalPrice)

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Load đơn hàng lên trang
        function displayPizzaOrder(paramOrderPizzaArr) {
            for (var index = 0; index < paramOrderPizzaArr.length; index++) {
                $('.pizza-order-container').append(`
             <div class="payment-product row">
                        <div class="col-6 payment-product-leftside">
                            <div class="row payment-leftside-item">
                                <div class="col-4 item-img">
                                    <img src=${paramOrderPizzaArr[index].imageUrl} alt="">
                                </div>
                                <div class="col-8 item-info text-left">
                                    <h5 class="payment-title-item">${paramOrderPizzaArr[index].name}</h5>
                                    <p class="payment-ingredient-item">beef patties, Iceberg lettuce, American cheese, pickles, ...</p>
                                </div>
                            </div>
                        </div>
                        <div class="col-6 payment-product-leftside">
                            <div class="container-item">
                                <div class="row payment-rightside-price">
                                    <div class="col-3 text-right" id="total-price">$${(paramOrderPizzaArr[index].price) * (paramOrderPizzaArr[index].quantity)}</div>
                                    <div class="col-8 d-flex flex-column align-items-center" id="quantity">
                                        <div class="wrapper text-center">
                                            <span data-id = "${paramOrderPizzaArr[index].id}" class="minus">-</span>
                                            <span class="num">${paramOrderPizzaArr[index].quantity}</span>
                                            <span data-id="${paramOrderPizzaArr[index].id}" class="plus">+</span>
                                        </div>
                                        <p data-id ="${paramOrderPizzaArr[index].id}" class="remove-item mt-2">Remove Item</p>
                                    </div>
                                    <div class="col-1 text-right" id="unit-price">$${paramOrderPizzaArr[index].price}</div>
                                </div>
                            </div>
                        </div>
                    </div>
            `);
            }
            $('.coupon-code').text(`0%`);
            displayTotalPrice(paramOrderPizzaArr);
            // Gán sự kiện cho nút giảm số lượng pizza
            $('.minus').on('click', decreaseNumber)
            // Gán sự kiện cho nút tăng số lượng pizza
            $('.plus').on('click', increaseNumber)
            //Gán sự kiện cho nút remove item
            $('.remove-item').on('click', removeOrder);
        }

        // Hàm giảm số lượng order 
        function decreaseNumber() {
            let vPizzaId = $(this).data('id');
            var vLocalStorageString = localStorage.getItem('Order Pizza');
            var vLocalStorageObj = JSON.parse(vLocalStorageString);
            for (let index = 0; index < vLocalStorageObj.length; index++) {
                if (vLocalStorageObj[index].id === vPizzaId && vLocalStorageObj[index].quantity > 1) {
                    vLocalStorageObj[index].quantity--;
                    if (vLocalStorageObj[index].quantity < 1) {
                        vLocalStorageObj[index].quantity = 1;
                    }
                }
            }
            vLocalStorageString = JSON.stringify(vLocalStorageObj);
            localStorage.setItem('Order Pizza', vLocalStorageString);
            $('.pizza-order-container').html('');
            displayPizzaOrder(vLocalStorageObj);
            $('.coupon-code').text(`0%`);
            displayTotalPrice(vLocalStorageObj);
        }

        // Hàm tăng số lượng order 
        function increaseNumber() {
            let vPizzaId = $(this).data("id");

            var vOrderString = localStorage.getItem('Order Pizza');
            var vOrderObj = JSON.parse(vOrderString);

            for (var index = 0; index < vOrderObj.length; index++) {
                if (vPizzaId === vOrderObj[index].id) {
                    vOrderObj[index].quantity++;
                }
            }

            vOrderString = JSON.stringify(vOrderObj)
            localStorage.setItem('Order Pizza', vOrderString);
            $('.pizza-order-container').html('');
            displayPizzaOrder(vOrderObj);
            $('.coupon-code').text(`0%`);
            displayTotalPrice(vOrderObj);
        }

        // Hàm xóa item khỏi đơn hàng
        function removeOrder() {
            var vPizzaId = $(this).data('id');
            console.log(vPizzaId)
            var vLocalStorageString = localStorage.getItem('Order Pizza');
            var vLocalStorageObj = JSON.parse(vLocalStorageString);
            var vNewObj = [];
            for (let index = 0; index < vLocalStorageObj.length; index++) {
                if (vLocalStorageObj[index].id != vPizzaId) {
                    vNewObj.push(vLocalStorageObj[index])
                }
            }
            if (vNewObj.length === 0) {
                localStorage.clear();
                window.location.href = 'Food Ordering.html';
            } else {
                vLocalStorageString = JSON.stringify(vNewObj);
                localStorage.setItem('Order Pizza', vLocalStorageString);
                $('.pizza-order-container').html('');
                displayPizzaOrder(vNewObj);
                $('.coupon-code').text(`0%`);
                displayTotalPrice(vNewObj);
            }

        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

        // Hàm hiển thị total
        function displayTotalPrice() {
            var vLocalStorageString = localStorage.getItem('Order Pizza');
            var vLocalStorageObj = JSON.parse(vLocalStorageString);
            var vVoucherCode = $('.input-voucher-code').val();
            var gTotalPriceObj = {
                voucherCode: null,
                voucherId: null,
                subtotal: 0,
                shippingFee: 20,
                coupon: 0,
                discountPrice: function () {
                    var result = 0;
                    if (this.coupon === 0) {
                        result = 0;
                        return result;
                    } else {
                        result = (this.coupon / 100) * (this.subtotal + this.shippingFee);
                        return result;
                    }
                },
                total: function () {
                    var result = this.subtotal + this.shippingFee - this.discountPrice();
                    return result;
                }
            }
            if (vVoucherCode != '') {
                $.ajax({
                    async: true,
                    url: gBASE_URL + "/vouchers" + "?voucherCode=" + vVoucherCode,
                    type: 'GET',
                    success: function (paramSuccess) {
                        gTotalPriceObj.voucherCode = paramSuccess[0].voucherCode;
                        gTotalPriceObj.voucherId = paramSuccess[0].id;
                        gTotalPriceObj.coupon = paramSuccess[0].discount;
                        gTotalPriceObj.subtotal = sumPrice(vLocalStorageObj);
                        $('.subtotal-price').text(`$${gTotalPriceObj.subtotal}`);
                        $('.coupon-code').text(`${gTotalPriceObj.coupon}%`);
                        $('.total-price-number').text(`$${gTotalPriceObj.total()}`);
                        // Gán sự kiện cho nút check out
                        $('#btn-check-out').on('click', function () {
                            $('.modal-payment').modal('show');
                            // Gán sự kiện cho nút checkbox
                            $("input:checkbox").on('click', function () {
                                var $box = $(this);
                                if ($box.is(":checked")) {
                                    var group = "input:checkbox[name='" + $box.attr("name") + "']";
                                    $(group).prop("checked", false);
                                    $(group).closest('.option-credit-card').css('background-color', 'white')
                                    $box.prop("checked", true);
                                    $box.closest('.option-credit-card').css('background-color', '#f0faf7');
                                } else {
                                    $box.prop("checked", false);
                                    $(group).closest('.option-credit-card').css('background-color', 'white')
                                }
                            });
                        })
                        // Gán sự kiện cho nút go to payment
                        $('.btn-go-to-payment').on('click', function () {

                            $(".overlay-cart").show();
                            onGoToPayClickWithCoupon(gTotalPriceObj);

                        })
                    },
                    error: function (paramError) {
                        alert('Mã giảm giá không tồn tại');
                        gTotalPriceObj.coupon = 0;
                        console.assert(paramError.responseText);
                    }
                })
            } else {
                gTotalPriceObj.coupon = 0;
                gTotalPriceObj.subtotal = sumPrice(vLocalStorageObj);
                $('.subtotal-price').text(`$${gTotalPriceObj.subtotal}`);
                $('.coupon-code').text(`${gTotalPriceObj.coupon}%`);
                $('.total-price-number').text(`$${gTotalPriceObj.total()}`);
                // Gán sự kiện cho nút check out
                $('#btn-check-out').on('click', function () {
                    $('.modal-payment').modal('show');
                    // Gán sự kiện cho nút checkbox
                    $("input:checkbox").on('click', function () {
                        var $box = $(this);
                        if ($box.is(":checked")) {
                            var group = "input:checkbox[name='" + $box.attr("name") + "']";
                            $(group).prop("checked", false);
                            $(group).closest('.option-credit-card').css('background-color', 'white')
                            $box.prop("checked", true);
                            $box.closest('.option-credit-card').css('background-color', '#f0faf7');
                        } else {
                            $box.prop("checked", false);
                            $(group).closest('.option-credit-card').css('background-color', 'white')
                        }
                    });
                })
                // Gán sự kiện cho nút go to payment không có coupon
                $('.btn-go-to-payment').on('click', function () {
                    // debugger
                    $(".overlay-cart").show();
                    onGoToPayClickWithOutCoupon(gTotalPriceObj);

                })
            }
        }

        //Hàm tính tổng số tiền
        function sumPrice(paramOrderObj) {
            var sum = 0;
            for (let index = 0; index < paramOrderObj.length; index++) {
                sum += (paramOrderObj[index].quantity) * (paramOrderObj[index].price)
            }
            return sum;
        }

        // Hàm xử lý sự kiện nhấn nút go to payment khi có coupon
        function onGoToPayClickWithCoupon(paramTotalPriceObj) {
            var vOrderWithCoupon = {
                firstName: "",
                lastName: "",
                email: "",
                address: "",
                phone: "",
                methodPayment: "",
                voucherId: null,
                details: []
            }
            // Thu thập dữ liệu
            collectDataWithCoupon(vOrderWithCoupon, paramTotalPriceObj);
            // Kiểm tra dữ liệu
            var vDataValiDated = checkData(vOrderWithCoupon);
            if (vDataValiDated) {
                $('.modal-payment').modal('hide');
                callApiPostOrderWithCoupon(vOrderWithCoupon);
            }
        }

        // Hàm xử lý sự kiện nhấn nút go to payment khi không có coupon
        function onGoToPayClickWithOutCoupon(paramTotalPriceObj) {
            console.log(paramTotalPriceObj);
            var vOrderWithCoupon = {
                firstName: "",
                lastName: "",
                email: "",
                address: "",
                phone: "",
                methodPayment: "",
                details: []
            }
            // Thu thập dữ liệu
            collectDataWithOutCoupon(vOrderWithCoupon, paramTotalPriceObj);
            console.log(vOrderWithCoupon);
            // Kiểm tra dữ liệu
            var vDataValiDated = checkData(vOrderWithCoupon);
            if (vDataValiDated) {
                $('.modal-payment').modal('hide');
                callApiPostOrderWithOutCoupon(vOrderWithCoupon);
            }
        }

        //Hàm thu thập dữ liệu có coupon
        function collectDataWithCoupon(paramObjWithCoupon, paramTotalPriceObj) {
            var vLocalStorageString = localStorage.getItem('Order Pizza');
            var vLocalStorageObj = JSON.parse(vLocalStorageString);
            console.log(vLocalStorageObj);
            paramObjWithCoupon.firstName = $.trim($('#input-firstname').val());
            paramObjWithCoupon.lastName = $.trim($('#input-lastname').val());
            paramObjWithCoupon.email = $.trim($('#input-email').val());
            paramObjWithCoupon.address = $.trim($('#textarea-message').val());
            paramObjWithCoupon.phone = $.trim($('#input-phone').val());
            paramObjWithCoupon.voucherId = paramTotalPriceObj.voucherId;
            for (let index = 0; index < vLocalStorageObj.length; index++) {
                var vOrderDetails = {
                    foodId: vLocalStorageObj[index].id,
                    quantity: vLocalStorageObj[index].quantity
                }
                paramObjWithCoupon.details.push(vOrderDetails);
            }

            if ($('#card-method').prop("checked")) {
                paramObjWithCoupon.methodPayment = 'CreditCard';
            } else if ($('#paypal-method').prop("checked")) {
                paramObjWithCoupon.methodPayment = 'Paypal';
            } else if ($('#bank-method').prop("checked")) {
                paramObjWithCoupon.methodPayment = 'BankTransfer';
            }

        }

        //Hàm thu thập dữ liệu không có coupon
        function collectDataWithOutCoupon(paramObjWithCoupon, paramTotalPriceObj) {
            var vLocalStorageString = localStorage.getItem('Order Pizza');
            var vLocalStorageObj = JSON.parse(vLocalStorageString);
            console.log(vLocalStorageObj);
            paramObjWithCoupon.firstName = $.trim($('#input-firstname').val());
            paramObjWithCoupon.lastName = $.trim($('#input-lastname').val());
            paramObjWithCoupon.email = $.trim($('#input-email').val());
            paramObjWithCoupon.address = $.trim($('#textarea-message').val());
            paramObjWithCoupon.phone = $.trim($('#input-phone').val());

            for (let index = 0; index < vLocalStorageObj.length; index++) {
                var vOrderDetails = {
                    foodId: vLocalStorageObj[index].id,
                    quantity: vLocalStorageObj[index].quantity
                }
                paramObjWithCoupon.details.push(vOrderDetails);
            }

            if ($('#card-method').prop("checked")) {
                paramObjWithCoupon.methodPayment = 'CreditCard';
            } else if ($('#paypal-method').prop("checked")) {
                paramObjWithCoupon.methodPayment = 'Paypal';
            } else if ($('#bank-method').prop("checked")) {
                paramObjWithCoupon.methodPayment = 'BankTransfer';
            }

        }

        // Hàm kiểm tra dữ liệu
        function checkData(paramObjWithCoupon) {
            let vValid = true;
            $(".form-control").removeClass("is-invalid")
            $("#checkbox-feedback").html("");
            //Các trường phải nhập hết
            if (paramObjWithCoupon.firstName === '') {
                $("#input-firstname").addClass("is-invalid")
                $("#input-firstname ~ .invalid-feedback").text("Please enter first name")
                vValid = false;
            }

            if (paramObjWithCoupon.lastName === '') {
                $("#input-lastname").addClass("is-invalid")
                $("#input-lastname ~ .invalid-feedback").text("Please enter last name")
                vValid = false;
            }

            // Email đúng định dạng
            var vEmailRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
            if (paramObjWithCoupon.email === '') {
                $("#input-email").addClass("is-invalid")
                $("#input-email ~ .invalid-feedback").text("Please enter email")
                vValid = false;
            } else if (vEmailRegex.test(paramObjWithCoupon.email) === false) {
                $("#input-email").addClass("is-invalid")
                $("#input-email ~ .invalid-feedback").text("Please enter valid email")
                vValid = false;
            }

            if (paramObjWithCoupon.address === '') {
                $("#textarea-message").addClass("is-invalid")
                $("#textarea-message ~ .invalid-feedback").text("Please enter address")
                vValid = false;
            }

            if (paramObjWithCoupon.phone === '') {
                $("#input-phone").addClass("is-invalid")
                $("#input-phone ~ .invalid-feedback").text("Please enter phone")
                vValid = false;
            }

            //Phải chọn 1 Method of Payment
            if (paramObjWithCoupon.methodPayment === '') {
                $("#checkbox-feedback").text("Please choose one method payment")
                vValid = false;
            }
            return vValid;
        }

        // Hàm gọi Api POST đơn hàng có coupon
        function callApiPostOrderWithCoupon(paramObjWithCoupon) {
            $.ajax({
                url: gBASE_URL + "/orders",
                type: 'POST',
                data: JSON.stringify(paramObjWithCoupon),
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (paramSuccess) {
                    console.log(paramSuccess)
                    $(".overlay-cart").hide();
                    $('.modal-success').modal('show');
                    $("#modal-btn-compete").click(function () {
                        $('.modal-success').modal('hide');
                    })

                },
                error: function (paramError) {
                    console.log(paramError.responseText)
                }
            })

        }

        // Hàm gọi Api POST đơn hàng không có coupon
        function callApiPostOrderWithOutCoupon(paramObjWithOutCoupon) {
            $.ajax({
                url: gBASE_URL + "/orders",
                type: 'POST',
                data: JSON.stringify(paramObjWithOutCoupon),
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (paramSuccess) {
                    console.log(paramSuccess)
                    $(".overlay-cart").hide();
                    $('.modal-success').modal('show');
                    $("#modal-btn-compete").click(function () {
                        $('.modal-success').modal('hide');
                    })
                },
                error: function (paramError) {
                    console.log(paramError.responseText)
                }
            })
        }

        // Hàm lấy dữ liệu từ local Storage 
        function getDataLocalStorage() {
            var vOrderPizzaString = localStorage.getItem('Order Pizza');
            vOrderPizzaArr = JSON.parse(vOrderPizzaString);
        }
    })

</script>

</html>